#include <stdio.h> 
#include <mega8.h>
#include <delay.h>

//  
#define STOP_N_GO   1   // /
#define SAVE_EEPROM 2   //     EEPROM
#define DEFAULT     3   //     
#define SLOWLY      4   //  - 
#define FASTER      5   //  -  
//        : 20
#define key_delay   20

//  "",    EEPROM         
eeprom int _OCR1A = 500;

int is_running = 1;     //  /
int step = 0;           //    ( 4 )
int key_name = 0;       //   
                                   
//  
int step_mass[] = {0b1001, 0b1100, 0b0110, 0b0011};
               
//   / 1
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{                                        
  //     .
  if (is_running == 1) {       
    //   
    step++;   
    step = step % 4;         
    //       ""   
    PORTC = step_mass[step];
  }                         
}

//          
void main(void)
{   
  //  
       
  //  / 1
  TCCR1A=0x00;
  TCCR1B=0x0C;  // clkI/O/256     
  //    
  //   EEPROM  
  if (_OCR1A > 0)                   
    OCR1A = _OCR1A;     //     EEPROM
    else OCR1A = 3630;  //    -
  
  //    / 1
  TIMSK=0x10;   // : Clear Timer on Compare Match (CTC)
                                        
  //     /
  //   C
  PORTC=0x0F;   //
  DDRC=0xFF;    // PC0..PC3   ( )
  //   D                 
  PORTD=0x1F;   // 
  DDRD=0xE0;    // PD0..PD4   ( )

  //    
  #asm("sei")  
     
  ////////////////////////////////////////
  //   
  //  
  ////////////////////////////////////////
  while (1) 
  {
    //    
    key_name = 0;
                            
    // ,    1 
    if(PIND.0==0) {
      //  
      delay_ms(key_delay);
      //      
      if(PIND.0==0) 
        //    
        key_name = STOP_N_GO; 
    }
    //   1  , 
    //     (2..5)
    else  
      if(PIND.1==0) {
        delay_ms(key_delay); 
        if(PIND.1==0) key_name = SAVE_EEPROM;  
      }
      else       
        if(PIND.2==0) {
          delay_ms(key_delay); 
          if(PIND.2==0) key_name = DEFAULT;  
        }
        else       
          if(PIND.3==0) {
            delay_ms(key_delay); 
            if(PIND.3==0) key_name = SLOWLY;  
          }
          else       
            if(PIND.4==0) {
              delay_ms(key_delay); 
              if(PIND.4==0) key_name = FASTER;  
            }
          
            
    //    
    switch (key_name)
    {
      case STOP_N_GO:
        // /
        is_running = !is_running;
        PORTC=0;
        break;
      case DEFAULT:  
        //     
        OCR1A=3630;
        break;
      case SAVE_EEPROM:
        //      ,
        //    EPPROM
        _OCR1A = OCR1A;
        break;
      case SLOWLY: 
        //  ,   
        if (OCR1A<30000) OCR1A+=100;
        break;
      case FASTER: 
        //  ,   
        if (OCR1A>100) OCR1A-=100;
        break;
    }
      
    //    
    //    PORTD.5 (.11)
    if (key_name > 0) 
    {           
      PORTD.5 = 1;    
      delay_ms(100);
      PORTD.5 = 0;    
      delay_ms(100);
    }  
  
  //    -   
  // :)  
  }
}
